VERSION 5.00
Begin VB.Form frmAsynchSplitter 
   BorderStyle     =   4  'Fixed ToolWindow
   Caption         =   "Splitter"
   ClientHeight    =   4560
   ClientLeft      =   45
   ClientTop       =   315
   ClientWidth     =   4980
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   4560
   ScaleWidth      =   4980
   StartUpPosition =   3  'Windows Default
   Begin VB.ListBox lstImages 
      Height          =   4350
      Left            =   2640
      TabIndex        =   6
      Top             =   60
      Width           =   2235
   End
   Begin VB.CommandButton cmdSplit 
      Caption         =   "Split"
      Height          =   495
      Left            =   60
      TabIndex        =   5
      Top             =   3960
      Width           =   2535
   End
   Begin VB.TextBox txtPath 
      Height          =   375
      Left            =   60
      TabIndex        =   4
      Top             =   3540
      Width           =   2535
   End
   Begin VB.PictureBox picProgress 
      AutoRedraw      =   -1  'True
      ForeColor       =   &H00008000&
      Height          =   315
      Left            =   60
      ScaleHeight     =   1
      ScaleMode       =   0  'User
      ScaleWidth      =   100
      TabIndex        =   1
      Top             =   2940
      Width           =   2535
   End
   Begin VB.PictureBox picThumbnail 
      AutoRedraw      =   -1  'True
      Height          =   2535
      Left            =   60
      ScaleHeight     =   165
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   165
      TabIndex        =   0
      Top             =   60
      Width           =   2535
   End
   Begin VB.Label Label2 
      Caption         =   "Path:"
      Height          =   315
      Left            =   60
      TabIndex        =   3
      Top             =   3300
      Width           =   2535
   End
   Begin VB.Label lblProgress 
      Caption         =   "Progress"
      Height          =   375
      Left            =   60
      TabIndex        =   2
      Top             =   2700
      Width           =   2535
   End
End
Attribute VB_Name = "frmAsynchSplitter"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Dim WithEvents WndHook  As clsTrickSubclass2
Attribute WndHook.VB_VarHelpID = -1

Dim ThreadData  As UserData

Private Sub cmdSplit_Click()
    Dim hThread As Long
    
    Set ThreadData.Stream = Nothing
    
    CreateStreamOnHGlobal 0, True, ThreadData.Stream
    
    ThreadData.NotifyWnd = Me.hWnd
    ThreadData.FindPath = SysAllocString(ByVal StrPtr(txtPath.Text))
    ThreadData.Progress = 0
    
    hThread = vbCreateThread(0, 0, AddressOf BackgroundThread, VarPtr(ThreadData), 0, 0)
    
    CloseHandle hThread
    
    If hThread Then
        cmdSplit.Enabled = False
        lstImages.Enabled = False
        lstImages.Clear
    End If
    
End Sub

Private Sub Form_Load()
    
    Set WndHook = New clsTrickSubclass2
    WndHook.Hook Me.hWnd
    
End Sub

Private Sub lstImages_Click()
    Dim pointer As Long
    Dim bitmap  As Long
    Dim gr      As Long
    Dim dat()   As Byte
    
    If ThreadData.Progress <> 1 Or lstImages.ListIndex < 0 Then Exit Sub
    
    pointer = lstImages.ItemData(lstImages.ListIndex)
    
    ReDim dat(ThumbnailSize * ThumbnailSize * 4 - 1)
    
    ThreadData.Stream.Seek CCur(pointer) / 10000@, STREAM_SEEK_SET
    ThreadData.Stream.Read dat(0), UBound(dat) + 1
    
    picThumbnail.Cls
    
    If GdipCreateBitmapFromScan0(ThumbnailSize, ThumbnailSize, ThumbnailSize * 4, PixelFormat32bppARGB, dat(0), bitmap) = 0 Then
        
        GdipCreateFromHDC picThumbnail.hdc, gr
        GdipDrawImageI gr, bitmap, (picThumbnail.ScaleWidth - ThumbnailSize) \ 2, (picThumbnail.ScaleHeight - ThumbnailSize) \ 2
        GdipDisposeImage bitmap
        GdipDeleteGraphics gr
        picThumbnail.Refresh
        
    End If
    
End Sub

Private Sub WndHook_WndProc(ByVal hWnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long, Ret As Long, DefCall As Boolean)
    Dim tmpStr  As String
    
    Select Case Msg
    Case UserMessages.SET_LABEL_CAPTION
    
        GetMem4 lParam, tmpStr
        lblProgress.Caption = tmpStr
    
    Case UserMessages.SET_PROGRESS
        
        picProgress.Cls
        picProgress.Line (0, 0)-(wParam, 1), , BF
        
        If wParam = 100 Then
        
            cmdSplit.Enabled = True
            lstImages.Enabled = True
            
        End If
    
    Case UserMessages.ADD_TO_LIST
    
        GetMem4 lParam, tmpStr
        lstImages.AddItem tmpStr
        lstImages.ItemData(lstImages.NewIndex) = wParam
        
    End Select
    
End Sub
