Attribute VB_Name = "modAPIDeclarations"
Option Explicit

Public Const WM_APP                 As Long = &H8000&
Public Const ImageLockModeRead      As Long = &H1
Public Const PixelFormat32bppARGB   As Long = &H26200A

Public Type GdiplusStartupInput
    GdiplusVersion              As Long
    DebugEventCallback          As Long
    SuppressBackgroundThread    As Long
    SuppressExternalCodecs      As Long
End Type

Public Type RECTL
    Left                        As Long
    Top                         As Long
    Right                       As Long
    Bottom                      As Long
End Type

Public Type BitmapData
    Width                       As Long
    Height                      As Long
    stride                      As Long
    PixelFormat                 As Long
    scan0                       As Long
    Reserved                    As Long
End Type

Public Declare Function PostMessage _
                        Lib "user32" _
                        Alias "PostMessageW" ( _
                        ByVal hWnd As Long, _
                        ByVal wMsg As Long, _
                        ByVal wParam As Long, _
                        ByRef lParam As Any) As Long
Public Declare Function SysAllocString _
                        Lib "oleaut32" ( _
                        ByRef pOlechar As Any) As Long
Public Declare Function GdiplusShutdown _
                        Lib "gdiplus" ( _
                        ByVal token As Long) As Long
Public Declare Function GdiplusStartup _
                        Lib "gdiplus" ( _
                        byreftoken As Long, _
                        ByRef inputbuf As GdiplusStartupInput, _
                        Optional ByVal outputbuf As Long = 0) As Long
Public Declare Function GdipLoadImageFromFile Lib "gdiplus" ( _
                        ByVal FileName As Long, _
                        ByRef image As Long) As Long
Public Declare Function GdipDisposeImage _
                        Lib "gdiplus" ( _
                        ByVal image As Long) As Long
Public Declare Function GdipGetImageThumbnail _
                        Lib "gdiplus" ( _
                        ByVal image As Long, _
                        ByVal thumbWidth As Long, _
                        ByVal thumbHeight As Long, _
                        thumbImage As Long, _
                        Optional ByVal callback As Long = 0, _
                        Optional ByVal callbackData As Long = 0) As Long
Public Declare Function GdipBitmapLockBits _
                        Lib "gdiplus" ( _
                        ByVal bitmap As Long, _
                        ByRef RECT As RECTL, _
                        ByVal flags As Long, _
                        ByVal PixelFormat As Long, _
                        ByRef lockedBitmapData As BitmapData) As Long
Public Declare Function GdipBitmapUnlockBits _
                        Lib "gdiplus" ( _
                        ByVal bitmap As Long, _
                        ByRef lockedBitmapData As BitmapData) As Long
Public Declare Function GdipCreateBitmapFromScan0 _
                        Lib "gdiplus" ( _
                        ByVal Width As Long, _
                        ByVal Height As Long, _
                        ByVal stride As Long, _
                        ByVal PixelFormat As Long, _
                        ByRef scan0 As Any, _
                        ByRef bitmap As Long) As Long
Public Declare Function GdipDrawImageI _
                        Lib "gdiplus" ( _
                        ByVal Graphics As Long, _
                        ByVal image As Long, _
                        ByVal x As Long, _
                        ByVal y As Long) As Long
Public Declare Function GdipCreateFromHDC _
                        Lib "gdiplus" ( _
                        ByVal hdc As Long, _
                        ByRef Graphics As Long) As Long
Public Declare Function GdipDeleteGraphics _
                        Lib "gdiplus" ( _
                        ByVal Graphics As Long) As Long
Public Declare Function CreateStreamOnHGlobal _
                        Lib "ole32" ( _
                        ByVal hGlobal As Long, _
                        ByVal fDeleteOnRelease As Long, _
                        ByRef ppstm As IStream) As Long




